<?php

/**
 * Created by PhpStorm.
 * User: wuxiande
 * Date: 2019/6/27
 * Time: 14:16
 * 中心服务接口
 */
class CenterAction extends Action
{
    function valid($sw_time,$sw_sign,$my_sign)
    {
        $result["code"]=0;
        $ts = time() - $sw_time;
        if ($ts<=-600||$ts>=600){
            $result["code"]=101;
            $result["msg"]="timeout!";
        }else{
            if ($sw_sign!=$my_sign){
                $result["code"]=102;
                $result["msg"]="sign err!";
            }
        }
        return $result;
    }
    /**
     * 系统配置接口
     */
    public function conf_sys(){
        $sql = "SELECT k,v FROM sh_system_config WHERE status=0 ORDER BY id ASC;";
        $arr = M("")->query($sql);
        foreach ($arr as $item){
            $result[$item["k"]]=$item["v"];
        }
        header('Content-type: application/json'); //json
        echo json_encode($result);
        exit;
    }

    /**
     * 合作方配置接口
     *
     */
    public function conf_sps(){
        $sql = "SELECT sp.id,sp.code,sp.push_type,sp.push_offset,config.type_code as k,config.v"
                ." FROM sh_sp sp,sh_sp_config config"
                ." WHERE sp.status=0 AND config.status=0 AND sp.id=config.sp_id ORDER BY sp.id ASC;";
        $arr = M("")->query($sql);
        foreach ($arr as $item){
            $result[$item["id"]]["id"]=$item["id"];
            $result[$item["id"]]["code"]=$item["code"];
            $result[$item["id"]]["push_type"]=$item["push_type"];
            $result[$item["id"]]["push_offset"]=$item["push_offset"];
            $result[$item["id"]][$item["k"]]=$item["v"];
        }
        header('Content-type: application/json'); //json
        echo json_encode($result);
        exit;
    }

    /**
     * 站点配置接口
     *
     */
    public function conf_sites(){
        $sql = "SELECT site.id,site.name,site.pull_api,site.offline_key,site.check_seconds,sp.spids FROM sh_site site"
            ." JOIN (SELECT site_id,GROUP_CONCAT(id) spids"
            ." FROM sh_sp WHERE status=0 GROUP BY site_id) sp ON sp.site_id=site.id"
            ." WHERE site.status=0;";
        $arr = M("")->query($sql);
        foreach ($arr as $item){
            $result[$item["id"]]["id"]=$item["id"];
            $result[$item["id"]]["name"]=$item["name"];
            $result[$item["id"]]["pull_api"]=$item["pull_api"];
            $result[$item["id"]]["offline_key"]=$item["offline_key"];
            $result[$item["id"]]["check_seconds"]=$item["check_seconds"];
            $result[$item["id"]]["spids"]=$item["spids"];
        }
        header('Content-type: application/json'); //json
        echo json_encode($result);
        exit;
    }

    public function push_log(){

    }

    /*
     * 媒资实时下线接口(华数经纬cms调用,下线媒资,同时需要下线所有酒店片库中相应媒资)
     * GET /api/center/media_offline?spid=1&mid=33431345&sw_time=1523345555&sw_sign=xxxxxx
     * 参数说明:
     *  spid :  合作方标识(我们提供,每个合作方标识不一样)
     *  mid :   媒资标识代码(经纬cms中的媒资id)
     *  sw_time :   请求时间戳
     *  sw_sign :   请求签名 md5(spid&mid&sw_time&key)
     * 返回说明:
     *  {"code":0,"msg":"ok"}
     *  code : 0-成功,101,1001-传入的媒资参数有问题,2001-下线失败
     *  注意:
     *      站点改造:spid传入siteid
     *      key从站点表获取 offline_key
     *      下线云端片库,下线关联站点的所以合作方酒店片库
     */
    public function media_offline(){
        $siteid = $_GET["spid"];
        $mid = $_GET["mid"];
        $sw_time = $_GET["sw_time"];
        $sw_sign =$_GET["sw_sign"];

        $status = 2;

        $modelSite=D("Site");
        $whereSite["id"]=$siteid;
        $spConf=$modelSite->field("offline_key")->where($whereSite)->find();
        $key = $spConf["offline_key"];

        if ($key) {
            $pre_sign = "$siteid&$mid&$sw_time&$key";
//            echo "pre:".$pre_sign;
            $my_sign = md5($pre_sign);
            $result = $this->valid($sw_time,$sw_sign,$my_sign);
            if ($result["code"]==0) {//valid ok
                $model = D("Media");
                $where["code"] = $mid;
                $where["site_id"] = $siteid;
                $tmp = $model->field("id")->where($where)->find();
                $id = $tmp["id"];
                if ($id) {

                    //下线云端片库
                    $data["id"] = $id;
                    $data["status"] = $status;
                    $data["updatetime"] = date('Y-m-d H:i:s');
                    $r = $model->save($data);

                    //下线该站点下所有关联合作方的酒店片库
                    $sql = "select id from sh_sp where site_id=$siteid";
                    $sps = M("")->query($sql);
                    $total = count($sps);
                    $nok = 0;
                    foreach ($sps as $sp){
                        $spid = $sp["id"];
                        $tb = "sh_hotel_media_map_$spid";
                        $sql = "update $tb set status=$status,updatetime='" . $data["updatetime"] . "' where media_id=$id";
                        $r = M("")->execute($sql);
                        if ($r)
                            $nok ++;
                    }
                    if ($total==$nok) {
                        $result["code"] = 0;
                        $result["msg"] = "ok";
                    } else {
                        $result["code"] = 2001;
                        $result["msg"] = "offline failture!";
                    }
                } else {
                    $result["code"] = 1001;
                    $result["msg"] = "media info unexpect!";
                }
            }
        }else{
            $result["code"]=1002;
            $result["msg"]="sp info unexpect";
        }

        echo json_encode($result);
        exit;
    }

    /**
     * 修改云端片库媒资信息
     *  参数:
     *      site_id
     *      sps : [{"sp_id":"1","push_mode":"1"},{"sp_id":"2","push_mode":"0"}]
     *      $json["jsonUrl"]
     *      $json["newsId"]
     *      $json["newsName"]
     *      $json["nodeId"]
     *      $json["nodeName"]
     *
     */
    public function media_update(){
       $rawData =  @file_get_contents("php://input");
        //echo $rawData."\n";
        $inputJson = json_decode($rawData,true);
        $site_id=$inputJson["site_id"];
        $url = $inputJson["jsonUrl"];

        $content = file_get_contents($url);
        $json = json_decode($content,true);
//        var_dump($json);

        $data['type'] = $json["type"];
        $data['title'] = $json["title"];
        $data['code'] = $json["id"];
        $data['description'] = $json["description"];
        $data['url_play'] = $json["playUrl"];
        $data['url_pic'] = $json["picUrl"];
        $data['year'] = substr($json["year"],0,4);
        $data['score'] = floatval($json["score"]);
        $data['region'] = $json["region"];
        $data['actor'] = $json["actor"];
        $data['director'] = $json["director"];
        $data['md5'] = $this->null2str($json["md5"]);
        $data['status'] = intval($json["status"]);
        $data["_starttime"]=$this->null2str($json["startTime"]);
        $data["_updatetime"]=$this->null2str($json["updateTime"]);
        $data["programType"]=$json["programType"];
        $data["nodeId"]=intval($json["nodeId"]);
        $data["site_id"]=intval($site_id);
        $data["nodeName"]=$this->null2str($json["nodeName"]);

        //圆动和互动新增字段()
        $data['newsImage_1'] = $this->null2str($json["newsImage_1"]);
        $data['newsImage_2'] = $this->null2str($json["newsImage_2"]);
        $data['newsImage_3'] = $this->null2str($json["newsImage_3"]);
        $data['englishTitle'] = $this->null2str($json["englishTitle"]);
        //end

        $model = D("Media");
        $where["code"]=$data["code"];
        $where["site_id"]=$data["site_id"];
        $tmp  = $model->field("id")->where($where)->find();
        $id= $tmp["id"];
//        var_dump($tmp);exit;
        $code=0;
        if($id){
            $data['id'] = $id;
            $data["updatetime"]=date('Y-m-d H:i:s');
            $r = $model->save($data);
//            echo $model->_sql();
            if($r){
                echo 'true';
            }else{
                echo 'false';
                $code=1001;
            }
        }else{
            $id = $model->add($data);
            $data["id"]=$id;
            if($id){
                echo 'true';
                $b=true;
            }else{
                echo 'false';
                $code=1002;
            }
        }
        //修改酒店片库
        $this->media_auto_push($data,$inputJson);


        if ($code){ //更新媒资失败: 记录拉取失败日志
            $this->log_pull_failture($code,$inputJson);
        }

        exit;
    }
    function log_pull_failture($code,&$json){
        $data["site_id"]=intval($json["site_id"]);
        $data["jsonUrl"]=$json["jsonUrl"];
        $data["newsId"]=$json["newsId"];
        $data["newsName"]=$json["newsName"];
        $data["nodeId"]=$json["nodeId"];
        $data["nodeName"]=$json["nodeName"];
        $data["code"]=$code;
        D("PullLog")->add($data);
    }
    function null2str($str){
        if (is_null($str)){
            $str="";
        }
        return $str;
    }
    /*
     * 媒资自动转推函数
     * 批量修改媒资状态
     * 批量推送添加
     */
    function media_auto_push(&$data,&$json){
        $sps = $json["sps"];
        foreach ($sps as $sp) {
            $push_mode = $sp["push_mode"];
            if ($push_mode==1) {
                $sp_id = $sp["sp_id"];
                $media_id = $data["id"];
                $status = $data["status"];

                $updateSQL = "UPDATE sh_hotel_media_map_$sp_id SET status=$status WHERE media_id=$media_id;";
                M('')->execute($updateSQL);

                $sql = "SELECT h.id,hm.media_id FROM sh_hotel h"
                    . " LEFT JOIN (SELECT media_id,hotel_id FROM sh_hotel_media_map_$sp_id WHERE media_id=$media_id) hm ON h.id=hm.hotel_id"
                    . " WHERE h.sp_id=$sp_id AND media_id IS NULL;";
                $arr = M("")->query($sql);

                foreach ($arr as $item) {
                    $dataList[] = array("media_id" => $media_id, "hotel_id" => $item["id"], "status" => $status, "status_inject" => 0);
                }

                if (!empty($dataList)) {
                    M("$sp_id", "sh_hotel_media_map_")->addAll($dataList);
                }
            }
        }

    }
    public function test_auto_push(){
        $json["site_id"]=1;
        //sps : [{"sp_id":"1","push_mode":"1"},{"sp_id":"2","push_mode":"0"}]
        $json["sps"]=array(array("sp_id"=>1,"push_mode"=>1),array("sp_id"=>2,"push_mode"=>0));

        $data["site_id"]=1;
        $data["id"]=300;
        $data["status"]=2;
        $this->media_auto_push($data,$json);
    }

    /**
     * 增量媒资变更列表
     * /Api/Front/incrementList?hid=1&spid=1&start=xxx&end=xxx&page=1
     * 输入:
     *      spid    :   合作方id
     *      start   :   开始时间
     *      end     :   结束时间
     *      page    :   请求页
     *      page_size : 每页记录数
     */
    public function incrementList(){
//        $page_size = 10;
        $page_size = $_GET["page_size"];
        if (empty($page_size)){
            $page_size = 10;
        }
        $whereHotelid = "1=1";
        $hid = $_GET["hid"];
        if (!empty($hid)){
            $whereHotelid = "hotel_id=$hid";
        }
        $spid = $_GET["spid"];
        $start = date('Y-m-d H:i:s',strtotime($_GET["start"]));//date('Y-m-d H:i:s', strtotime($date))
        $end = date('Y-m-d H:i:s',strtotime($_GET["end"]));
        $page=$_GET["page"];

        $sqlTotal = "SELECT count(1) total FROM sh_hotel_media_map_$spid WHERE $whereHotelid AND hm.status_inject=1 AND updatetime BETWEEN '$start' AND '$end';";
        $totalArr = M("")->query($sqlTotal);
        $total = 0;
        if (count($totalArr)>0){
            $total = $totalArr[0]["total"];
        }
        $page_num = ceil($total/$page_size);
        $limit_from = ($page-1)*$page_size;

        $fields = "mw.code id,mw.title,mw.description,mw.programType,mw.url_pic picUrl"
            . ",mw.year,mw.type,mw.score,mw.region,mw.actor,mw.director"
            . ",hm.code hotelId,hm.status,hm.status_inject statusInject"
            . ",mw.type,mw.nodeId,mw.nodeName"
            . ",mw.newsImage_1,mw.newsImage_2,mw.newsImage_3,mw.englishTitle";
        $sql = "SELECT $fields"
            . " FROM (SELECT hm.media_id,h.code,hm.status,hm.status_inject FROM sh_hotel_media_map_$spid hm,sh_hotel h"
            . " WHERE $whereHotelid AND hm.status_inject=1 AND hm.updatetime BETWEEN '$start' AND '$end' AND h.id=hm.hotel_id ORDER BY hm.updatetime,hm.media_id ASC LIMIT $limit_from,$page_size) hm"
            . " JOIN sh_media_wasu mw ON mw.id=hm.media_id";

//        echo $sql;exit;
        $list = M("")->query($sql);

        $result["total"]=(int)$total;
        $result["page_cur"]=(int)$page;
        $result["page_num"]=(int)$page_num;
        $result["list"] = $list;

        header('Content-type: application/json'); //json
        echo json_encode($result);
        exit;
    }
    /**
     * 增量媒资变更检测接口
     * /Api/Center/incrementCheck?spid=1&start=20190701120000&end=20190702120000&page=1
     * 输入:
     *      spid    :   合作方id
     *      start   :   开始时间
     *      end     :   结束时间
     * 输出:
     *  {"total":100,"page_cur":1,"page_num":10}
     */
    public function incrementCheck(){
        $page_size = 10;

        $rawData = @file_get_contents("php://input");
        $json = json_decode($rawData, true);

        if (isset($json["spid"])) {
            $spid = $json["spid"];
            $start = date('Y-m-d H:i:s', strtotime($json["start"]));//date('Y-m-d H:i:s', strtotime($date))
            $end = date('Y-m-d H:i:s', strtotime($json["end"]));
        }else{
            $spid = $_GET["spid"];
            $start = date('Y-m-d H:i:s', strtotime($_GET["start"]));//date('Y-m-d H:i:s', strtotime($date))
            $end = date('Y-m-d H:i:s', strtotime($_GET["end"]));
        }

        $sqlTotal = "SELECT count(1) total FROM sh_hotel_media_map_$spid WHERE status_inject=1 AND updatetime BETWEEN '$start' AND '$end';";
        $totalArr = M("")->query($sqlTotal);
        $total = 0;
        if (count($totalArr)>0){
            $total = (int)$totalArr[0]["total"];
        }
        $page_num = ceil($total/$page_size);

        $result["total"]=$total;
        $result["page_num"]=$page_num;

        echo json_encode($result);
        exit;
    }

    /**
     * 增量媒资变更推送接口
     * /Api/Center/incrementPush
     * 输入:
     *      spid    :   合作方id
     *      start   :   开始时间
     *      end     :   结束时间
     *      page    :   请求页
     *      page_num:   总共多少页
     *      url     :   合作方接收地址
     *      key     :   私钥
     * 输出:
     *  {"code":0,"msg":"err msg"}
     */
    public function incrementPush()
    {
        $page_size = 10;

        $rawData = @file_get_contents("php://input");
//        echo "rawData:".$rawData;
        $json = json_decode($rawData, true);

        $spid = $json["spid"];
        $start = date('Y-m-d H:i:s', strtotime($json["start"]));
        $end = date('Y-m-d H:i:s', strtotime($json["end"]));
        $page = $json["page"];
        $pageNum = $json["page_num"];
        $url = $json["url"];
        $key = $json["key"];

        $result["code"] = 0;

        if($url!=""&&$key!="") {

            $limit_from = ($page - 1) * $page_size;

            $fields = "mw.code id,mw.title,mw.description,mw.programType,mw.url_pic picUrl"
                . ",mw.year,mw.type,mw.score,mw.region,mw.actor,mw.director"
                . ",hm.code hotelId,hm.status,hm.status_inject statusInject"
                . ",mw.type,mw.nodeId,mw.nodeName"
                . ",mw.newsImage_1,mw.newsImage_2,mw.newsImage_3,mw.englishTitle";

            $sql = "SELECT $fields"
                . " FROM (SELECT hm.media_id,h.code,hm.status,hm.status_inject FROM sh_hotel_media_map_$spid hm,sh_hotel h"
                . " WHERE hm.updatetime AND hm.status_inject=1 BETWEEN '$start' AND '$end' AND h.id=hm.hotel_id ORDER BY hm.updatetime,hm.media_id ASC LIMIT $limit_from,$page_size) hm"
                . " JOIN sh_media_wasu mw ON mw.id=hm.media_id";

//        echo $sql;exit;
            $list = M("")->query($sql);//获取增量媒资列表
//            $json = json_encode($list,JSON_UNESCAPED_UNICODE);// php >= 5.4
            $json=json_encode($list);
            //请求合作方接口将变更列表推送
            $sw_time = time();
            $sw_sign = md5($sw_time . $key);
            $api_push = $url . "?sw_time=$sw_time&sw_sign=$sw_sign";

//            echo $api_push;
//            echo "<br/>";
//            echo $sw_time . $key;
//            echo "<br/>";
//            echo $json;
//            exit;

            $data = $this->HttpPost($api_push, $json);
//            echo "post result: ".$data;
            $jsonR = json_decode($data, true);

            if ($jsonR["code"] == 0) {
                //最后一页推送成功:更新offset
                if ($page == $pageNum) {
                    M()->execute("UPDATE sh_sp SET push_offset='$end' WHERE id=$spid;");
                }
            }
            if (!empty($jsonR) && $jsonR["code"]==0){
                $result["code"]=0;
            }else{
                $result["code"]=2001;
                $result["msg"]="合作方接口调用异常:".$data;
            }
        }else{
            $result["code"]=1001;
            $result["msg"]="合作方配置不完整";
        }

        if ($result["code"]!=0){
            $log["sp_id"]=$spid;
            $log["starttime"]=$start;
            $log["endtime"]=$end;
            $log["page"]=$page;
            $log["req_json"]=$rawData;
            $log["resp_json"]=$data;
            $log["code"]=$result["code"];
            D("PushLog")->add($log);
        }
        echo json_encode($result);
        exit;
    }



    public function tb_playlog_create(){
        //参数
        $curMonth = date("Ym");
        $nextMonth = date("Ym",strtotime("+1 month"));

        //创建表
        $srcTable = "sh_log_play";
        $curMonthTable = $srcTable."_".$curMonth;
        $nextMonthTable = $srcTable."_".$nextMonth;

        $this->createTable($srcTable,$curMonthTable);
        $this->createTable($srcTable,$nextMonthTable);
    }


    //------ 表创建方法  ------
    function createTable($srcTable,$targetTable){
        echo $srcTable."->".$targetTable;
        $qsql="SELECT table_name FROM information_schema.TABLES WHERE table_name = '$targetTable';";
        $arrTables = D("")->query($qsql);
        if (count ($arrTables)<=0){
            $csql = "CREATE TABLE $targetTable LIKE $srcTable;";
            D("")->execute($csql);
        }
    }

    function HttpPost($url,$param){
        $ch = curl_init();
        //如果$param是数组的话直接用
        curl_setopt($ch, CURLOPT_URL, $url);
        //如果$param是json格式的数据，则打开下面这个注释
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                'Content-Type: application/json',
                'Content-Length: ' . strlen($param))
        );
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $param);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        //如果用的协议是https则打开鞋面这个注释
        // curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        // curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);

        $data = curl_exec($ch);

        curl_close($ch);
        return $data;

    }
}