#!/bin/bash
. /etc/profile
. ~/.bash_profile

log_path=/dev/shm/logs
log_tmp_path=/dev/shm/logs_tmp
day=`date "+%Y-%m-%d"`
hour=`date "+%H"`
f=/data1/backup_log/ngx/$day/$hour
index=1
backup_path=$f
while : ; do
    if [ -d $backup_path ]; then
        backup_path=$f.$index
        index=$(($index+1))
    else
        break
    fi
done
mkdir -p $log_tmp_path
mv $log_path/* $log_tmp_path
service nginx reopen
sleep 3

cd $log_tmp_path
for logfile in `ls ./`;do
    fz=$(stat -c "%s" $logfile)
    if [ $fz -gt 512 ]; then
        tar -czf $logfile.tgz $logfile --remove-files
    fi
done

mkdir -p $backup_path
mv $log_tmp_path/* $backup_path

###remove old log
if [ $hour == "00" ]; then
    oldday=`date -d "3 months ago" "+%Y-%m-%d"`
    rm -rf /data1/backup_log/ngx/$oldday
fi

